/*
 * Thread-related utilities.
 *
 * Copyright (C) 2024 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#include <l4/re/env.h>

#include <pthread-l4.h>
#include <pthread.h>

#include "thread.h"



l4_cap_idx_t get_current_thread()
{
  l4_cap_idx_t thread = pthread_l4_cap(pthread_self());

  /* NOTE: On MIPS32, at least, in a payload started by libexec, the main thread
           is not necessarily returned correctly. */

  if (l4_is_invalid_cap(thread))
    return l4re_env()->main_thread;

  return thread;
}
